package com.company.testkvdatagrid.web.screens.newentity;

import com.haulmont.cuba.core.entity.KeyValueEntity;
import com.haulmont.cuba.core.global.Metadata;
import com.haulmont.cuba.gui.Notifications;
import com.haulmont.cuba.gui.model.CollectionPropertyContainer;
import com.haulmont.cuba.gui.model.InstanceContainer;
import com.haulmont.cuba.gui.model.KeyValueCollectionContainer;
import com.haulmont.cuba.gui.screen.*;
import com.company.testkvdatagrid.entity.NewEntity;

import javax.inject.Inject;
import java.util.List;

@UiController("testkvdatagrid_NewEntity.edit")
@UiDescriptor("new-entity-edit.xml")
@EditedEntityContainer("newEntityDc")
@LoadDataBeforeShow
public class NewEntityEdit extends StandardEditor<NewEntity> {
    @Inject
    private KeyValueCollectionContainer kvsDc;
    @Inject
    private Metadata metadata;
    @Inject
    private Notifications notifications;

    @Subscribe
    public void onInitEntity(InitEntityEvent<NewEntity> event) {
        final List<KeyValueEntity> mutableItems = kvsDc.getMutableItems();
        mutableItems.add(metadata.create(KeyValueEntity.class));
        mutableItems.add(metadata.create(KeyValueEntity.class));
    }

    @Subscribe(id = "kvsDc", target = Target.DATA_CONTAINER)
    public void onDetailsDcItemPropertyChange(InstanceContainer.ItemPropertyChangeEvent<KeyValueEntity> event) {
        notifications.create(Notifications.NotificationType.SYSTEM).withCaption(event.getProperty() + ": " + event.getValue()).show();
    }



}